Index: palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d	(revision 3924)
+++ palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d	(revision 4012)
@@ -19,8 +19,5 @@
 !-- Numerics
 !------------------------------------------------------------------------------
-    psolver              = 'multigrid',
-    momentum_advec       = 'ws-scheme',  ! default advection scheme
-    scalar_advec         = 'ws-scheme', 
-    conserve_volume_flow = .T.,
+    fft_method           = 'fftw',
 
 !
@@ -28,27 +25,27 @@
 !------------------------------------------------------------------------------     
     humidity             = .T.,
-    q_surface            = 0.008,
+    q_surface            = 0.001,
 
 !
 !-- Initialization
 !------------------------------------------------------------------------------
-    initializing_actions = 'set_constant_profiles',
-
-    pt_surface           = 293.15,
+    initializing_actions = 'set_constant_profiles',   !'set_constant_profiles', or 'inifor', 
+                                                      ! or both (met. from inifor, chem constant profiles)
+
+    pt_surface           = 277.15,
     ug_surface           = 1.0,
     vg_surface           = 0.0,
 
-    roughness_length     = 0.05,
-    neutral              = .T.,
-    
-    day_of_year_init     =  65,          ! March 06, to avoid extreme temperatures
-    time_utc_init        = 71700.0,      !(19:55, UTC in seconds)
-
-!
-!-- Boundary conditions
-!------------------------------------------------------------------------------ 
-    bc_lr                = 'cyclic', 
-    bc_ns                = 'cyclic',
-    bc_uv_t              = 'dirichlet',  ! channel flow boundary condition
+    day_of_year_init     = 65,             ! march 06, to avoid extreme temperatures
+    time_utc_init        = 36000.0,        ! (0.0 s = 00 UTC midnight),
+
+!
+!-- Wall/soil spinup
+!------------------------------------------------------------------------------    
+    spinup_time         = 1200.0,
+    spinup_pt_mean      = 284.15,
+    spinup_pt_amplitude = 10.0,             ! give a dirunal cycle from 6 - 16 Â°C
+    dt_spinup           = 120.0,
+    data_output_during_spinup = .F.,
 
 !
@@ -60,7 +57,7 @@
 !-- Physics
 !------------------------------------------------------------------------------
-    longitude            = 13.4,         ! Berlin longitude
-    latitude             = 52.5,         ! Berlin latitude
-      
+    longitude            = 13.4,
+    latitude             = 52.5,
+
  / ! end of inipar namelist
 
@@ -79,29 +76,97 @@
 
 !
-!-- General output settings
-!------------------------------------------------------------------------------
-    netcdf_data_format    = 4,           ! use NetCDF4
-
-!
 !-- Run-control/timeseries output settings
 !------------------------------------------------------------------------------
     dt_run_control        =  0.0,
-    dt_dots               =  0.0,
-
+    dt_dots               =  10.0,
+
+!
+!-- Profile output settings
+!------------------------------------------------------------------------------
+    skip_time_dopr        =  0.0,
+    dt_dopr               = 60.0,
+    averaging_interval_pr = 60.0,
+    dt_averaging_input_pr =  0.0,
+
+    data_output_pr        = '#u',  'u*2',  'wu',  'w*u*',  'w"u"',
+                            '#v',  'v*2',  'wv',  'w*v*',  'w"v"',
+!                            'w',   'w*2',
+                            '#theta', 'theta*2', 'wtheta', 'w*theta*', 'w"theta"',
+                            '#q',  'q*2', 
 !
 !-- 2D/3D output settings
 !------------------------------------------------------------------------------
     do3d_at_begin      = .T., 
-
-    dt_data_output     = 10.0,
-
+    do2d_at_begin      = .T.,
+
+    dt_data_output     = 10.0, 
+    dt_data_output_av  = 10.0,
+    averaging_interval = 10.0,
+    dt_averaging_input =  0.0,
+
+    section_xy         = 0,
 
     data_output = 'u', 'v', 'w',
-                  'Ntot', 'LDSA', 'PM2.5', 's_OC', 's_NH', 's_NO', 
-                  'g_H2SO4','g_HNO3','g_NH3','g_OCNV','g_OCSV',
+                  'Ntot', 'PM2.5', 'LDSA',
+                  's_OC','g_OCNV','g_OCSV',
                   'N_bin3', 'm_bin4', 
 
+
  / ! end of d3par namelist
 
+
+!-------------------------------------------------------------------------------
+!-- RADIATION MODEL PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/radpar
+!-------------------------------------------------------------------------------
+  &radiation_parameters
+
+     radiation_scheme =  'clear-sky',    !'clear-sky' or 'rrtmg',
+     albedo_type = 5,
+     constant_albedo = .F.,
+
+     dt_radiation = 60.0,
+
+     surface_reflections = .T.,
+     nrefsteps = 3,
+
+     rad_angular_discretization = .F.,
+     raytrace_mpi_rma = .F.,
+
+  /
+
+
+!-------------------------------------------------------------------------------
+!-- LAND SURFACE MODEL PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/lsmpar
+!------------------------------------------------------------------------------- 
+ &land_surface_parameters 
+
+    constant_roughness     = .T.,
+    aero_resist_kray       = .T.,
+
+    vegetation_type        = 2,
+    soil_type              = 3,
+    conserve_water_content = .T.,
+
+    root_fraction          = 0.49, 0.26, 0.25, 0.0, 0.0, 0.0, 0.0, 0.0,
+    soil_temperature       = 277.15, 277.0, 277.0, 277.0, 277.0, 277.0, 277.0, 277.0, 
+    soil_moisture          = 0.30,   0.30,  0.30,  0.30,  0.30, 0.30,  0.30,  0.30,
+    deep_soil_temperature  = 277.0,
+    
+ / ! end of lsm_par namelist
+
+
+!-------------------------------------------------------------------------------
+!-- URBAN SURFACE MODEL PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/usmpar
+!-------------------------------------------------------------------------------
+ &urban_surface_parameters
+
+    usm_material_model     = .T.,
+    usm_wall_mod = .T.,
+
+ / ! end of urban_surface_par namelist
+ 
 
 !-------------------------------------------------------------------------------
@@ -112,5 +177,5 @@
  
     canopy_mode       = 'read_from_file_3d',
-    canopy_drag_coeff = 0.5,
+    canopy_drag_coeff = 0.3,
       
  / ! end of canopy_par namelist