Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 3990)
+++ palm/trunk/SOURCE/modules.f90	(revision 4017)
@@ -1195,5 +1195,4 @@
     INTEGER(iwp) ::  dots_time_count = 0               !< number of output intervals for timeseries output
     INTEGER(iwp) ::  dp_level_ind_b = 0                !< lowest grid index for external pressure gradient forcing
-    INTEGER(iwp) ::  dvrp_filecount = 0                !< parameter for dvr visualization software
     INTEGER(iwp) ::  ensemble_member_nr = 0            !< namelist parameter
     INTEGER(iwp) ::  gamma_mg                          !< switch for steering the multigrid cycle: 1: v-cycle, 2: w-cycle
@@ -1460,5 +1459,4 @@
     REAL(wp) ::  dt_do2d_yz = 9999999.9_wp                     !< namelist parameter
     REAL(wp) ::  dt_do3d = 9999999.9_wp                        !< namelist parameter
-    REAL(wp) ::  dt_dvrp = 9999999.9_wp                        !< namelist parameter
     REAL(wp) ::  dt_max = 20.0_wp                              !< namelist parameter
     REAL(wp) ::  dt_restart = 9999999.9_wp                     !< namelist parameter
@@ -1545,5 +1543,4 @@
     REAL(wp) ::  time_do_av = 0.0_wp                           !< time since last averaged-data output
     REAL(wp) ::  time_do_sla = 0.0_wp                          !< time since last 
-    REAL(wp) ::  time_dvrp = 0.0_wp                            !< time since last dvrp output
     REAL(wp) ::  time_restart = 9999999.9_wp                   !< time at which run shall be terminated and restarted
     REAL(wp) ::  time_run_control = 0.0_wp                     !< time since last RUN_CONTROL output
@@ -1627,123 +1624,4 @@
 
  END MODULE control_parameters
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Definition of variables used with dvrp-software.
-!------------------------------------------------------------------------------!
- MODULE dvrp_variables
-
-    USE kinds
-
-    CHARACTER (LEN=10) ::  dvrp_output = 'rtsp'        !< dvr namelist parameter
-    CHARACTER (LEN=10) ::  particle_color = 'none'     !< dvr namelist parameter
-    CHARACTER (LEN=10) ::  particle_dvrpsize = 'none'  !< dvr namelist parameter
-
-    CHARACTER (LEN=20), DIMENSION(10) ::  mode_dvrp = &  !< dvr namelist parameter
-                                     (/ ( '                    ', i9 = 1,10 ) /)
-
-    CHARACTER (LEN=80) ::  dvrp_directory = 'default'                     !< dvr namelist parameter
-    CHARACTER (LEN=80) ::  dvrp_file      = 'default'                     !< dvr namelist parameter
-    CHARACTER (LEN=80) ::  dvrp_host      = 'origin.rvs.uni-hannover.de'  !< dvr namelist parameter
-    CHARACTER (LEN=80) ::  dvrp_password  = '********'                    !< dvr namelist parameter
-    CHARACTER (LEN=80) ::  dvrp_username  = ' '                           !< dvr namelist parameter
-
-    INTEGER(iwp) ::  cluster_size = 1                   !< dvr namelist parameter
-    INTEGER(iwp) ::  dvrp_colortable_entries = 4        !< internal dvr software variable
-    INTEGER(iwp) ::  dvrp_colortable_entries_prt = 22   !< internal dvr software variable
-    INTEGER(iwp) ::  islice_dvrp                        !< internal dvr software variable
-    INTEGER(iwp) ::  nx_dvrp                            !< internal dvr software variable
-    INTEGER(iwp) ::  nxl_dvrp                           !< internal dvr software variable
-    INTEGER(iwp) ::  nxr_dvrp                           !< internal dvr software variable
-    INTEGER(iwp) ::  ny_dvrp                            !< internal dvr software variable
-    INTEGER(iwp) ::  nyn_dvrp                           !< internal dvr software variable
-    INTEGER(iwp) ::  nys_dvrp                           !< internal dvr software variable
-    INTEGER(iwp) ::  nz_dvrp                            !< internal dvr software variable
-    INTEGER(iwp) ::  pathlines_fadeintime = 5           !< dvr namelist parameter
-    INTEGER(iwp) ::  pathlines_fadeouttime = 5          !< dvr namelist parameter
-    INTEGER(iwp) ::  pathlines_linecount = 1000         !< dvr namelist parameter
-    INTEGER(iwp) ::  pathlines_maxhistory = 40          !< dvr namelist parameter
-    INTEGER(iwp) ::  pathlines_wavecount = 10           !< dvr namelist parameter
-    INTEGER(iwp) ::  pathlines_wavetime = 50            !< dvr namelist parameter
-    INTEGER(iwp) ::  vc_gradient_normals = 0            !< dvr namelist parameter
-    INTEGER(iwp) ::  vc_mode = 0                        !< dvr namelist parameter
-    INTEGER(iwp) ::  vc_size_x = 2                      !< dvr namelist parameter
-    INTEGER(iwp) ::  vc_size_y = 2                      !< dvr namelist parameter
-    INTEGER(iwp) ::  vc_size_z = 2                      !< dvr namelist parameter
-
-    INTEGER(iwp), DIMENSION(10) ::  slicer_position_dvrp  !< internal dvr software variable
-
-    LOGICAL ::  cyclic_dvrp = .FALSE.                      !< internal dvr software variable
-    LOGICAL ::  dvrp_overlap                               !< internal dvr software variable
-    LOGICAL ::  dvrp_total_overlap                         !< internal dvr software variable
-    LOGICAL ::  local_dvrserver_running                    !< namelist parameter (ENVPAR namelist provided by palmrun)
-    LOGICAL ::  lock_steering_update = .FALSE.             !< internal dvr software variable
-    LOGICAL ::  use_seperate_pe_for_dvrp_output = .FALSE.  !< internal dvr software variable
-
-    REAL(wp) ::  clip_dvrp_l = 9999999.9_wp  !< dvr namelist parameter
-    REAL(wp) ::  clip_dvrp_n = 9999999.9_wp  !< dvr namelist parameter
-    REAL(wp) ::  clip_dvrp_r = 9999999.9_wp  !< dvr namelist parameter
-    REAL(wp) ::  clip_dvrp_s = 9999999.9_wp  !< dvr namelist parameter
-    REAL(wp) ::  superelevation = 1.0_wp     !< dvr namelist parameter
-    REAL(wp) ::  superelevation_x = 1.0_wp   !< dvr namelist parameter
-    REAL(wp) ::  superelevation_y = 1.0_wp   !< dvr namelist parameter
-    REAL(wp) ::  vc_alpha = 38.0_wp          !< dvr namelist parameter
-
-    REAL(wp), DIMENSION(2) ::  color_interval = (/ 0.0_wp, 1.0_wp /)     !< dvr namelist parameter
-    REAL(wp), DIMENSION(2) ::  dvrpsize_interval = (/ 0.0_wp, 1.0_wp /)  !< dvr namelist parameter
-
-    REAL(wp), DIMENSION(3) ::  groundplate_color = (/ 0.0_wp, 0.6_wp, 0.0_wp /)  !< dvr namelist parameter
-    REAL(wp), DIMENSION(3) ::  topography_color = (/ 0.8_wp, 0.7_wp, 0.6_wp /)   !< dvr namelist parameter
-
-    REAL(wp), DIMENSION(2,10) ::  slicer_range_limits_dvrp  !< dvr namelist parameter
-
-    REAL(wp), DIMENSION(3,10) ::  isosurface_color  !< dvr namelist parameter
-
-    REAL(sp), DIMENSION(2,100) ::  interval_values_dvrp          !< internal dvr software variable
-    REAL(sp), DIMENSION(2,100) ::  interval_values_dvrp_prt      !< internal dvr software variable
-    REAL(sp), DIMENSION(2,100) ::  interval_h_dvrp               !< internal dvr software variable
-    REAL(sp), DIMENSION(2,100) ::  interval_h_dvrp_prt           !< internal dvr software variable
-    REAL(sp), DIMENSION(2,100) ::  interval_l_dvrp = 0.5_sp      !< internal dvr software variable
-    REAL(sp), DIMENSION(2,100) ::  interval_l_dvrp_prt = 0.5_sp  !< internal dvr software variable
-    REAL(sp), DIMENSION(2,100) ::  interval_s_dvrp = 1.0_sp      !< internal dvr software variable
-    REAL(sp), DIMENSION(2,100) ::  interval_s_dvrp_prt = 1.0_sp  !< internal dvr software variable
-    REAL(sp), DIMENSION(2,100) ::  interval_a_dvrp = 0.0_sp      !< internal dvr software variable
-    REAL(sp), DIMENSION(2,100) ::  interval_a_dvrp_prt = 0.0_sp  !< internal dvr software variable
-
-    DATA  slicer_range_limits_dvrp / -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, &  !< internal dvr software variable
-                                     -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, &
-                                     -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, &
-                                     -1.0_wp, 1.0_wp /
-
-    DATA  isosurface_color / 0.9_wp, 0.9_wp, 0.9_wp,  0.8_wp, 0.1_wp, 0.1_wp,  0.1_wp, 0.1_wp, 0.8_wp, &  !< internal dvr software variable
-                             0.1_wp, 0.8_wp, 0.1_wp,  0.6_wp, 0.1_wp, 0.1_wp,  0.1_wp, 0.1_wp, 0.6_wp, &
-                             0.1_wp, 0.6_wp, 0.1_wp,  0.4_wp, 0.1_wp, 0.1_wp,  0.1_wp, 0.1_wp, 0.4_wp, &
-                             0.1_wp, 0.4_wp, 0.1_wp /
-
-    DATA  interval_h_dvrp / 270.0_wp, 225.0_wp, 225.0_wp, 180.0_wp, 70.0_wp, 25.0_wp, &  !< internal dvr software variable
-                            25.0_wp, -25.0_wp, 192 * 0.0_wp /
-
-    DATA  interval_h_dvrp_prt / 270.0_wp, 225.0_wp, 225.0_wp, 180.0_wp, 70.0_wp, 25.0_wp, &  !< internal dvr software variable
-                                25.0_wp, -25.0_wp, 192 * 0.0_wp /
-
-    REAL(sp), DIMENSION(:), ALLOCATABLE ::  xcoor_dvrp  !< internal dvr software variable
-    REAL(sp), DIMENSION(:), ALLOCATABLE ::  ycoor_dvrp  !< internal dvr software variable
-    REAL(sp), DIMENSION(:), ALLOCATABLE ::  zcoor_dvrp  !< internal dvr software variable
-
-    TYPE steering
-       CHARACTER (LEN=24) ::  name  !< internal dvr software variable
-       REAL(sp)           ::  min   !< internal dvr software variable
-       REAL(sp)           ::  max   !< internal dvr software variable
-       INTEGER(iwp)       ::  imin  !< internal dvr software variable
-       INTEGER(iwp)       ::  imax  !< internal dvr software variable
-    END TYPE steering
-
-    TYPE(steering), DIMENSION(:), ALLOCATABLE ::  steering_dvrp  !< internal dvr software variable
-
-    SAVE
-
- END MODULE dvrp_variables
 
 