Index: palm/trunk/SCRIPTS/palm_csd_files/palm_csd_canopy_generator.py
===================================================================
--- palm/trunk/SCRIPTS/palm_csd_files/palm_csd_canopy_generator.py	(revision 4022)
+++ palm/trunk/SCRIPTS/palm_csd_files/palm_csd_canopy_generator.py	(revision 4023)
@@ -20,9 +20,12 @@
 # Current revisions:
 # -----------------
-# Added support for tree shape
+# 
 # 
 # Former revisions:
 # -----------------
 # $Id: palm_csd_canopy_generator.py 3773 2019-03-01 08:56:57Z maronga $
+# Added support for tree shape
+# 
+# 3773 2019-03-01 08:56:57Z maronga
 # Bugfix: conversion to integer required for indexing
 # 
Index: palm/trunk/SCRIPTS/palm_csd_files/palm_csd_tools.py
===================================================================
--- palm/trunk/SCRIPTS/palm_csd_files/palm_csd_tools.py	(revision 4022)
+++ palm/trunk/SCRIPTS/palm_csd_files/palm_csd_tools.py	(revision 4023)
@@ -20,10 +20,13 @@
 # Current revisions:
 # -----------------
-# Bugfix: missing conversion to integer
-#
+# 
 # 
 # Former revisions:
 # -----------------
 # $Id: palm_csd_tools.py 3773 2019-03-01 08:56:57Z maronga $
+# Bugfix: missing conversion to integer
+#
+# 
+# 3773 2019-03-01 08:56:57Z maronga
 # Unspecified changes
 # 
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 4022)
+++ palm/trunk/SOURCE/header.f90	(revision 4023)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Renamed "coupling start time" to "spinup time"
+! 
+! 4017 2019-06-06 12:16:46Z schwenkel
 ! unused variable removed
 ! 
@@ -2005,5 +2008,5 @@
              '                                      per second of simulated tim', &
                'e: ',F9.3,' s')
-207 FORMAT ( ' Coupling start time: ',F9.3,' s')
+207 FORMAT ( ' Spinup time:         ',F9.3,' s')
 250 FORMAT (//' Computational grid and domain size:'/ &
               ' ----------------------------------'// &
Index: palm/trunk/SOURCE/time_integration_spinup.f90
===================================================================
--- palm/trunk/SOURCE/time_integration_spinup.f90	(revision 4022)
+++ palm/trunk/SOURCE/time_integration_spinup.f90	(revision 4023)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Time stamps are now negative in run control output
+! 
+! 3885 2019-04-11 11:29:34Z kanani
 ! Changes related to global restructuring of location messages and introduction 
 ! of additional debug messages
@@ -176,5 +179,9 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=9) ::  time_to_string          !< 
+    CHARACTER (LEN=9) ::  time_to_string                  !< 
+  
+  
+    CHARACTER (LEN=1) ::  sign_chr                        !< String containing '-' or ' ' 
+    CHARACTER (LEN=9) ::  time_since_reference_point_chr  !< time since reference point, i.e., negative during spinup
   
     INTEGER(iwp) ::  i !< running index
@@ -449,5 +456,13 @@
        simulated_time_chr         = time_to_string( simulated_time )
        time_since_reference_point = simulated_time - coupling_start_time
-
+       time_since_reference_point_chr = time_to_string( ABS(time_since_reference_point) )
+       
+       IF ( time_since_reference_point < 0.0_wp )  THEN
+          sign_chr = '-'
+       ELSE
+          sign_chr = ' '
+       ENDIF
+      
+       
        IF ( data_output_during_spinup )  THEN
           IF ( simulated_time >= skip_time_do2d_xy )  THEN
@@ -548,5 +563,5 @@
 !
 !--       Write some general information about the spinup in run control file
-          WRITE ( 15, 101 )  current_timestep_number_spinup, simulated_time_chr, dt_3d, pt_spinup
+          WRITE ( 15, 101 )  current_timestep_number_spinup, sign_chr, time_since_reference_point_chr, dt_3d, pt_spinup
 !
 !--       Write buffer contents to disc immediately
@@ -583,8 +598,8 @@
 !-- Formats
 100 FORMAT (///'Spinup control output:'/  &
-            '--------------------------------'// &
-            'ITER.  HH:MM:SS    DT   PT(z_MO)'/   &
-            '--------------------------------')
-101 FORMAT (I5,2X,A9,1X,F6.2,3X,F6.2,2X,F6.2)
+            '---------------------------------'// &
+            'ITER.   HH:MM:SS    DT   PT(z_MO)'/   &
+            '---------------------------------')
+101 FORMAT (I5,2X,A1,A9,1X,F6.2,3X,F6.2,2X,F6.2)
 
  CONTAINS